<!--- improved form is less leaky (information disclosure is minimized)
	  this is just a sample approach. multiple solutions are possible.
 --->

<!--- get data without DB from XML file in WDDX format --->
<cffile action="read" variable="strWddx" file="D:\Tomcat\webapps\railo\sec\form\groupData.xml">
<cfwddx action="wddx2cfml" input="#strWddx#" output="selGroups">
<cfquery name="selUserGroups" dbtype="query">
	SELECT * 
	FROM selGroups
	WHERE groupClass ='standard'
</cfquery>

<cfoutput>
	<h2>Enhanced Web Form -- #Now()#</h2>

	<form name="enhancedForm" action="formTarget.cfm" method="post">
		<!--- hidden user id ? --->
		<input type="hidden" name="#sff('userId')#" value="#formEncrypt(22)#">
		<!--- a standard input field --->
		Name : <input type="text" name="#sff('firstName')#" size="30"><br/>
		<!--- a select field populated from query --->
		Department:
		<select name="#sff('departmentId')#">
			<!--- by setting the queries'' current row as the option value we can check on the processing 
			      page whether a value is passed that is outside 
			      the range of possible values by simply comparing against recordcount --->
			<cfoutput query="selUserGroups">
				<option value="#selUserGroups.currentRow#">#selUserGroups.groupName#</option>		
			</cfoutput>	
		</select> <br/>
		
		<!--- Send accross the query so we can verify provided data --->
		<input type="hidden" value="#formEncrypt(selUserGroups)#">
		
		<input type="submit" name="submit" value="submit">
	
	</form>
</cfoutput>

<!--- helper function to set form field names (set form field=sff) --->
<cffunction name="sff" returntype="string" output="false">
	<cfargument name="input" type="any" hint="prepare input to be used as form ID or Name" required="true">	

	<cfset var strReturn = "X" & formEncrypt(arguments.input,false,"HEX")>
	
	<cfreturn strReturn>
</cffunction>



<!--- returns encrypted text  --->
<cffunction name="formEncrypt" output="false">
	<cfargument name="input" type="any" hint="anything we need to encrypt" required="true">	
	<cfargument name="serialize" type="boolean" default="true" hint="for non complex (string or number) we can skip serialization if so directed">
	<cfargument name="encoding" type="string" default="Base64" hint="encryption encoding (Base64,Hex, etc.)">
	
	<cfset var strReturn=arguments.input>
	<cfset setEncryptionKey()>
	
	<cfif Not IsSimpleValue(strReturn) OR arguments.serialize>
		<cfset strReturn = SerializeJSON(arguments.input)>
	</cfif>
	
	<cfset strReturn = XMLFormat(encrypt(strReturn,Request.encryptionKey,"AES",arguments.encoding))>

	<cfreturn strReturn>
</cffunction>


<cffunction name="setEncryptionKey" hint="sets the encryption key in the cache and request scope so we can use it">
	<cfset var strCacheKey="encryptionKey">
	<!--- check whether request scope already has key already set, if so, nothing else to do --->
	<cfif Not IsDefined("Request.encryptionKey")>
		<!--- check if Key is in cash if so get from cache, otherwise create and set in cache and request scope --->
		<cfif Not arrayFindNoCase(cacheGetAllIds(), strCacheKey)>
			<cfset Request.encryptionKey=generateSecretKey("AES")>
			<cfset cachePut(strCacheKey, Request.encryptionKey, createTimeSpan(1,0,0,0))>
		<cfelse>		
			<cfset Request.encryptionKey = cacheGet(strCacheKey)>
		</cfif>		
	</cfif>
</cffunction>

